Index: tmp/org.txm.setups/nsis/Include/nsDialogs.nsh
===================================================================
--- tmp/org.txm.setups/nsis/Include/nsDialogs.nsh	(revision 2955)
+++ tmp/org.txm.setups/nsis/Include/nsDialogs.nsh	(revision 2956)
@@ -295,358 +442,587 @@
 
 	Pop $1
 	Pop $0
-
 !macroend
 
 !macro __NSD_DefineControlCallback EVENT
-
-	!define NSD_On${EVENT} `!insertmacro __NSD_OnControlEvent ${EVENT}`
-
+	!define NSD_On${EVENT} `!insertmacro __NSD_OnControlEvent ${EVENT} `
 !macroend
 
 !macro __NSD_OnDialogEvent EVENT FUNCTION
-
 	Push $0
 
 	GetFunctionAddress $0 "${FUNCTION}"
 	nsDialogs::On${EVENT} $0
 
 	Pop $0
-
 !macroend
 
 !macro __NSD_DefineDialogCallback EVENT
-
-	!define NSD_On${EVENT} `!insertmacro __NSD_OnDialogEvent ${EVENT}`
-
+	!define NSD_On${EVENT} `!insertmacro __NSD_OnDialogEvent ${EVENT} `
 !macroend
-
 !insertmacro __NSD_DefineControlCallback Click
 !insertmacro __NSD_DefineControlCallback Change
 !insertmacro __NSD_DefineControlCallback Notify
 !insertmacro __NSD_DefineDialogCallback Back
 
+!define NSD_Return "!insertmacro NSD_Return "
+!macro NSD_Return val
+StrCpy $_OUTDIR ${val}
+SetSilent silent
+Return
+!macroend
+
+
+!define __NSD_MkCtlCmd "!insertmacro __NSD_MkCtlCmd "
+!macro __NSD_MkCtlCmd msg wp lp hCtl
+SendMessage ${hCtl} ${${msg}} ${wp} ${lp}
+!macroend
+!define __NSD_MkCtlCmd_WP "!insertmacro __NSD_MkCtlCmd_WP "
+!macro __NSD_MkCtlCmd_WP msg lp hCtl wp
+SendMessage ${hCtl} ${${msg}} ${wp} ${lp}
+!macroend
+!define __NSD_MkCtlCmd_LP "!insertmacro __NSD_MkCtlCmd_LP "
+!macro __NSD_MkCtlCmd_LP msg wp hCtl lp
+SendMessage ${hCtl} ${${msg}} ${wp} ${lp}
+!macroend
+!define __NSD_MkCtlCmd_WPLP "!insertmacro __NSD_MkCtlCmd_WPLP "
+!macro __NSD_MkCtlCmd_WPLP msg hCtl wp lp
+SendMessage ${hCtl} ${${msg}} ${wp} ${lp}
+!macroend
+!define __NSD_MkCtlCmd_RV "!insertmacro __NSD_MkCtlCmd_RV "
+!macro __NSD_MkCtlCmd_RV msg wp lp hCtl VAR
+SendMessage ${hCtl} ${${msg}} ${wp} ${lp} ${VAR}
+!macroend
+
+
+!define NSD_InitCommonControlsEx "!insertmacro __NSD_InitCommonControlsEx "
+!macro __NSD_InitCommonControlsEx ICC
+!pragma warning push
+!pragma warning disable 7070 ; Invalid number
+!if ${ICC} <> 0
+!define /ReDef /IntFmt NSD_InitCommonControlsEx_TEMP "0x%X" ${ICC}
+System::Call 'COMCTL32::InitCommonControlsEx(*l${NSD_InitCommonControlsEx_TEMP}00000008)'
+!undef NSD_InitCommonControlsEx_TEMP
+!else
+System::Int64Op ${ICC} << 32
+System::Int64Op 8 | 
+System::Call 'COMCTL32::InitCommonControlsEx(*ls)' ; INITCOMMONCONTROLSEX as UINT64
+!endif
+!pragma warning pop
+!macroend
+!define NSD_InitCommonControl_IPAddress `${NSD_InitCommonControlsEx} ${ICC_INTERNET_CLASSES}`
+!define NSD_InitCommonControl_NetAddress `System::Call SHELL32::InitNetworkAddressControl()i`
+!define NSD_InitCommonControl_SysLink `${NSD_InitCommonControlsEx} ${ICC_LINK_CLASS}`
+
+
+!define NSD_CreateTimer `!insertmacro _NSD_CreateTimer `
 !macro _NSD_CreateTimer FUNCTION INTERVAL
-
 	Push $0
 
 	GetFunctionAddress $0 "${FUNCTION}"
 	nsDialogs::CreateTimer $0 "${INTERVAL}"
 
 	Pop $0
-
 !macroend
 
-!define NSD_CreateTimer `!insertmacro _NSD_CreateTimer`
 
+!define NSD_KillTimer `!insertmacro _NSD_KillTimer `
 !macro _NSD_KillTimer FUNCTION
-
 	Push $0
 
 	GetFunctionAddress $0 "${FUNCTION}"
 	nsDialogs::KillTimer $0
 
 	Pop $0
+!macroend
 
+
+!define NSD_AddStyle "!insertmacro _NSD_GWLAddFlags ${GWL_STYLE} "
+!define NSD_AddExStyle "!insertmacro _NSD_GWLAddFlags ${GWL_EXSTYLE} "
+!macro _NSD_GWLAddFlags GWL HWND DATA
+	System::Call "user32::GetWindowLong(p${HWND},i${GWL})p.s"
+	System::Int64Op "${DATA}" |
+	System::Call "user32::SetWindowLong(p${HWND},p${GWL},ps)"
 !macroend
 
-!define NSD_KillTimer `!insertmacro _NSD_KillTimer`
+!define NSD_RemoveStyle "!insertmacro _NSD_GWLRemoveFlags ${GWL_STYLE} " 
+!define NSD_RemoveExStyle "!insertmacro _NSD_GWLRemoveFlags ${GWL_EXSTYLE} "
+!macro _NSD_GWLRemoveFlags GWL HWND DATA
+System::Call "user32::GetWindowLong(p${HWND},i${GWL})p.s"
+System::Int64Op "${DATA}" ~ & ; Perform ~ and prepare the stack for &
+System::Int64Op ; Perform &
+System::Call "user32::SetWindowLong(p${HWND},i${GWL},ps)"
+!macroend 
 
-!macro _NSD_AddStyle CONTROL STYLE
+!define NSD_GetStyle "!insertmacro _NSD_GWLGetFlags ${GWL_STYLE} "
+!define NSD_GetExStyle "!insertmacro _NSD_GWLGetFlags ${GWL_EXSTYLE} "
+!macro _NSD_GWLGetFlags GWL HWND RET
+System::Call "user32::GetWindowLong(p${HWND},i${GWL})p.s"
+Pop ${RET}
+!macroend
 
-	Push $0
+!macro __NSD_GetStyleBit GWL BIT HWND RET
+!insertmacro _NSD_GWLGetFlags ${GWL} ${HWND} ${RET}
+IntOp ${RET} ${RET} & ${BIT}
+!macroend
 
-	System::Call "user32::GetWindowLong(i ${CONTROL}, i ${GWL_STYLE}) i .r0"
-	System::Call "user32::SetWindowLong(i ${CONTROL}, i ${GWL_STYLE}, i $0|${STYLE})"
 
-	Pop $0
+!define NSD_SetFocus `!insertmacro __NSD_SetFocus `
+!macro __NSD_SetFocus HWND
+	System::Call "user32::SetFocus(p${HWND})"
+!macroend
 
+
+!define NSD_GetText "!insertmacro __NSD_GetText "
+!macro __NSD_GetText CONTROL VAR
+	System::Call user32::GetWindowText(p${CONTROL},t.s,i${NSIS_MAX_STRLEN})
+	Pop ${VAR}
 !macroend
 
-!define NSD_AddStyle "!insertmacro _NSD_AddStyle"
 
-!macro _NSD_AddExStyle CONTROL EXSTYLE
+!define NSD_SetText "!insertmacro __NSD_SetText "
+!macro __NSD_SetText CONTROL TEXT
+	SendMessage ${CONTROL} ${WM_SETTEXT} 0 `STR:${TEXT}`
+!macroend
 
-	Push $0
 
-	System::Call "user32::GetWindowLong(i ${CONTROL}, i ${GWL_EXSTYLE}) i .r0"
-	System::Call "user32::SetWindowLong(i ${CONTROL}, i ${GWL_EXSTYLE}, i $0|${EXSTYLE})"
+### Edit ###
 
-	Pop $0
+!define NSD_Edit_GetTextLimit `${__NSD_MkCtlCmd_RV} EM_GETLIMITTEXT 0 0 `
+!define NSD_Edit_SetTextLimit `${__NSD_MkCtlCmd_WP} EM_SETLIMITTEXT 0 `
+!define NSD_Edit_SetPasswordChar `${__NSD_MkCtlCmd_WP} EM_SETPASSWORDCHAR 0 `
+!define NSD_Edit_GetReadOnly `!insertmacro __NSD_GetStyleBit ${GWL_STYLE} ${ES_READONLY} ` ; Non-zero if read-only
+!define NSD_Edit_SetReadOnly `${__NSD_MkCtlCmd_WP} EM_SETREADONLY 0 ` ; Toggles the ES_READONLY style
+!define NSD_Edit_GetModify `${__NSD_MkCtlCmd_RV} EM_GETMODIFY 0 0 `
+!define NSD_Edit_SetModify `${__NSD_MkCtlCmd_WP} EM_SETMODIFY 0 `
+!define NSD_Edit_EmptyUndoBuffer `${__NSD_MkCtlCmd} EM_EMPTYUNDOBUFFER 0 0 `
+!define NSD_Edit_CanUndo `${__NSD_MkCtlCmd_RV} EM_CANUNDO 0 0 `
+!define NSD_Edit_ScrollCaret `${__NSD_MkCtlCmd} EM_SCROLLCARET 0 0 `
+!define NSD_Edit_LineScroll `${__NSD_MkCtlCmd_WPLP} EM_LINESCROLL `
+!define NSD_Edit_SetSel `${__NSD_MkCtlCmd_WPLP} EM_SETSEL ` ; WP:Start LP:End
 
+!define NSD_Edit_SetCueBannerText "!insertmacro __NSD_Edit_SetCueBannerText " ; CC6+
+!macro __NSD_Edit_SetCueBannerText CONTROL SHOWWHENFOCUSED TEXT
+!if ${NSIS_CHAR_SIZE} > 1
+	SendMessage ${CONTROL} ${EM_SETCUEBANNER} ${SHOWWHENFOCUSED} `STR:${TEXT}`
+!else
+	System::Call 'USER32::SendMessage(p${CONTROL},i${EM_SETCUEBANNER},p${SHOWWHENFOCUSED},ws)' `${TEXT}` ; Must be PWSTR
+!endif
 !macroend
 
-!define NSD_AddExStyle "!insertmacro _NSD_AddExStyle"
+!define NSD_Edit_GetLineCount `${__NSD_MkCtlCmd_RV} EM_GETLINECOUNT 0 0 `
+!define NSD_Edit_GetLine "!insertmacro __NSD_Edit_GetLine "
+!macro __NSD_Edit_GetLine CONTROL LINEINDEX OUTPUT
+	System::Call '*(&i2 ${NSIS_MAX_STRLEN},&t${NSIS_MAX_STRLEN})p.s'
+	System::Call 'USER32::SendMessage(p${CONTROL},i${EM_GETLINE},p${LINEINDEX},pss)'
+	System::Call 'KERNEL32::lstrcpyn(t.s,pss,i${NSIS_MAX_STRLEN})'
+	Pop ${OUTPUT}
+	System::Free
+!macroend
 
-!macro __NSD_GetText CONTROL VAR
+!define NSD_SetTextLimit `${NSD_Edit_SetTextLimit} ` ; Legacy alias
 
-	System::Call user32::GetWindowText(i${CONTROL},t.s,i${NSIS_MAX_STRLEN})
-	Pop ${VAR}
 
-!macroend
+### RichEdit ###
 
-!define NSD_GetText `!insertmacro __NSD_GetText`
+!define NSD_RichEd_SetTextLimit `${__NSD_MkCtlCmd_LP} EM_EXLIMITTEXT 0 `
+!define NSD_RichEd_GetEventMask `${__NSD_MkCtlCmd_RV} EM_GETEVENTMASK 0 0 `
+!define NSD_RichEd_SetEventMask `${__NSD_MkCtlCmd_LP} EM_SETEVENTMASK 0 ` ; LP:ENM_*
+!define NSD_RichEd_SetSystemBackgroundColor `${__NSD_MkCtlCmd} EM_SETBKGNDCOLOR 1 0 ` ; COLOR_WINDOW
+!define NSD_RichEd_SetCustomBackgroundColor `${__NSD_MkCtlCmd_LP} EM_SETBKGNDCOLOR 0 ` ; LP:COLORREF
+!define NSD_RichEd_SetHideSelection `${__NSD_MkCtlCmd_WP} EM_HIDESELECTION 0 ` ; WP(BOOL):HideSelWithoutFocus (Toggles ES_NOHIDESEL & TXTBIT_HIDESELECTION)
 
-!macro __NSD_SetText CONTROL TEXT
 
-	SendMessage ${CONTROL} ${WM_SETTEXT} 0 `STR:${TEXT}`
+### CheckBox ###
 
+!define NSD_GetState `!insertmacro __NSD_GetState `
+!macro __NSD_GetState CONTROL VAR
+	SendMessage ${CONTROL} ${BM_GETCHECK} 0 0 ${VAR}
 !macroend
 
-!define NSD_SetText `!insertmacro __NSD_SetText`
 
-!macro _NSD_SetTextLimit CONTROL LIMIT
+!define NSD_SetState `!insertmacro __NSD_SetState `
+!macro __NSD_SetState CONTROL STATE
+	SendMessage ${CONTROL} ${BM_SETCHECK} ${STATE} 0
+!macroend
 
-	SendMessage ${CONTROL} ${EM_SETLIMITTEXT} ${LIMIT} 0
+!define NSD_Check `!insertmacro __NSD_Check `
+!macro __NSD_Check CONTROL
+	${NSD_SetState} ${CONTROL} ${BST_CHECKED}
+!macroend
 
+
+!define NSD_Uncheck `!insertmacro __NSD_Uncheck `
+!macro __NSD_Uncheck CONTROL
+	${NSD_SetState} ${CONTROL} ${BST_UNCHECKED}
 !macroend
 
-!define NSD_SetTextLimit "!insertmacro _NSD_SetTextLimit"
+!define NSD_GetChecked `!insertmacro __NSD_GetState `
+!define NSD_SetChecked `!insertmacro __NSD_SetState `
 
-!macro __NSD_GetState CONTROL VAR
 
-	SendMessage ${CONTROL} ${BM_GETCHECK} 0 0 ${VAR}
+### ComboBox ###
 
+!define NSD_CB_AddString "!insertmacro _NSD_CB_AddString "
+!macro _NSD_CB_AddString CONTROL STRING
+	SendMessage ${CONTROL} ${CB_ADDSTRING} 0 `STR:${STRING}`
 !macroend
 
-!define NSD_GetState `!insertmacro __NSD_GetState`
 
-!macro __NSD_SetState CONTROL STATE
+!define NSD_CB_InsertString "!insertmacro _NSD_CB_InsertString "
+!macro _NSD_CB_InsertString CONTROL INDEX STRING
+SendMessage ${CONTROL} ${CB_INSERTSTRING} ${INDEX} `STR:${STRING}`
+!macroend
 
-	SendMessage ${CONTROL} ${BM_SETCHECK} ${STATE} 0
+!define NSD_CB_PrependString "!insertmacro _NSD_CB_PrependString "
+!macro _NSD_CB_PrependString CONTROL STRING
+SendMessage ${CONTROL} ${CB_INSERTSTRING} 0 `STR:${STRING}`
+!macroend
 
+!define NSD_CB_AppendString "!insertmacro _NSD_CB_AppendString "
+!macro _NSD_CB_AppendString CONTROL STRING
+SendMessage ${CONTROL} ${CB_INSERTSTRING} -1 `STR:${STRING}`
 !macroend
 
-!define NSD_SetState `!insertmacro __NSD_SetState`
 
-!macro __NSD_Check CONTROL
+!define NSD_CB_SelectString "!insertmacro _NSD_CB_SelectString "
+!macro _NSD_CB_SelectString CONTROL STRING
+	SendMessage ${CONTROL} ${CB_SELECTSTRING} -1 `STR:${STRING}`
+!macroend
 
-	${NSD_SetState} ${CONTROL} ${BST_CHECKED}
 
+!define NSD_CB_GetSelectionIndex `!insertmacro __NSD_CB_GetSelectionIndex `
+!macro __NSD_CB_GetSelectionIndex CONTROL VAR
+	SendMessage ${CONTROL} ${CB_GETCURSEL} 0 0 ${VAR}
 !macroend
 
-!define NSD_Check `!insertmacro __NSD_Check`
 
-!macro __NSD_Uncheck CONTROL
+!define NSD_CB_SetSelectionIndex `!insertmacro __NSD_CB_SetSelectionIndex `
+!macro __NSD_CB_SetSelectionIndex CONTROL INDEX
+	SendMessage ${CONTROL} ${CB_SETCURSEL} ${INDEX} 0
+!macroend
 
-	${NSD_SetState} ${CONTROL} ${BST_UNCHECKED}
 
+!define NSD_CB_GetItemData `!insertmacro __NSD_CB_GetItemData `
+!macro __NSD_CB_GetItemData CONTROL INDEX VAR
+SendMessage ${CONTROL} ${CB_GETITEMDATA} ${INDEX} 0 ${VAR}
 !macroend
+!define NSD_CB_SetItemData `${__NSD_MkCtlCmd_WPLP} CB_SETITEMDATA ` ; Index Data
 
-!define NSD_Uncheck `!insertmacro __NSD_Uncheck`
 
-!macro __NSD_SetFocus HWND
+!define NSD_CB_DelItem `${__NSD_MkCtlCmd_WP} CB_DELETESTRING 0 `
+!define NSD_CB_LimitText `${__NSD_MkCtlCmd_WP} CB_LIMITTEXT 0 `
+!define /IfNDef NSD_CB_Clear `${__NSD_MkCtlCmd} CB_RESETCONTENT 0 0 `
+!define /IfNDef NSD_CB_GetCount `${__NSD_MkCtlCmd_RV} CB_GETCOUNT 0 0 `
+!ifndef NSD_CB_DelString
+!define NSD_CB_DelString `!insertmacro __NSD_CB_DelString `
+!macro __NSD_CB_DelString CONTROL STRING
+	System::Call 'USER32::SendMessage(p${CONTROL},i${CB_FINDSTRINGEXACT},p-1,ts)p.s' `${STRING}`
+	System::Call 'USER32::SendMessage(p${CONTROL},i${CB_DELETESTRING},ps,p0)'
+!macroend
+!endif
+;define /IfNDef NSD_CB_GetSelection
 
-	System::Call "user32::SetFocus(i${HWND})"
-  
+
+### ListBox ###
+
+!define NSD_LB_AddString "!insertmacro _NSD_LB_AddString "
+!macro _NSD_LB_AddString CONTROL STRING
+	SendMessage ${CONTROL} ${LB_ADDSTRING} 0 `STR:${STRING}`
 !macroend
 
-!define NSD_SetFocus `!insertmacro __NSD_SetFocus`
 
-!macro _NSD_CB_AddString CONTROL STRING
+!define NSD_LB_InsertString "!insertmacro _NSD_LB_InsertString "
+!macro _NSD_LB_InsertString CONTROL INDEX STRING
+SendMessage ${CONTROL} ${LB_INSERTSTRING} ${INDEX} `STR:${STRING}`
+!macroend
 
-	SendMessage ${CONTROL} ${CB_ADDSTRING} 0 `STR:${STRING}`
+!define NSD_LB_PrependString "!insertmacro _NSD_LB_PrependString "
+!macro _NSD_LB_PrependString CONTROL STRING
+SendMessage ${CONTROL} ${LB_INSERTSTRING} 0 `STR:${STRING}`
+!macroend
 
+!define NSD_LB_AppendString "!insertmacro _NSD_LB_AppendString "
+!macro _NSD_LB_AppendString CONTROL STRING
+SendMessage ${CONTROL} ${LB_INSERTSTRING} -1 `STR:${STRING}`
 !macroend
 
-!define NSD_CB_AddString "!insertmacro _NSD_CB_AddString"
 
-!macro _NSD_CB_SelectString CONTROL STRING
+!define NSD_LB_DelString `!insertmacro __NSD_LB_DelString `
+!macro __NSD_LB_DelString CONTROL STRING
+	System::Call 'USER32::SendMessage(p${CONTROL},i${LB_FINDSTRINGEXACT},p-1,ts)p.s' `${STRING}`
+	System::Call 'USER32::SendMessage(p${CONTROL},i${LB_DELETESTRING},ps,p0)'
+!macroend
 
-	SendMessage ${CONTROL} ${CB_SELECTSTRING} -1 `STR:${STRING}`
 
+!define NSD_LB_DelItem "!insertmacro __NSD_LB_DelItem "
+!macro __NSD_LB_DelItem CONTROL INDEX
+	SendMessage ${CONTROL} ${LB_DELETESTRING} ${INDEX} 0
 !macroend
 
-!define NSD_CB_SelectString "!insertmacro _NSD_CB_SelectString"
 
-!macro _NSD_LB_AddString CONTROL STRING
+!define NSD_LB_Clear `${__NSD_MkCtlCmd} LB_RESETCONTENT 0 0 `
 
-	SendMessage ${CONTROL} ${LB_ADDSTRING} 0 `STR:${STRING}`
 
+!define NSD_LB_GetCount `!insertmacro __NSD_LB_GetCount `
+!macro __NSD_LB_GetCount CONTROL VAR
+	SendMessage ${CONTROL} ${LB_GETCOUNT} 0 0 ${VAR}
 !macroend
 
-!define NSD_LB_AddString "!insertmacro _NSD_LB_AddString"
 
-!macro __NSD_LB_DelString CONTROL STRING
+!define NSD_LB_SelectString "!insertmacro _NSD_LB_SelectString "
+!macro _NSD_LB_SelectString CONTROL STRING
+	SendMessage ${CONTROL} ${LB_SELECTSTRING} -1 `STR:${STRING}`
+!macroend
 
-	SendMessage ${CONTROL} ${LB_DELETESTRING} 0 `STR:${STRING}`
 
+!define NSD_LB_GetSelection `!insertmacro __NSD_LB_GetSelection `
+!macro __NSD_LB_GetSelection CONTROL VAR
+	SendMessage ${CONTROL} ${LB_GETCURSEL} 0 0 ${VAR}
+	System::Call 'user32::SendMessage(p ${CONTROL}, i ${LB_GETTEXT}, p ${VAR}, t .s)'
+	Pop ${VAR}
 !macroend
 
-!define NSD_LB_DelString `!insertmacro __NSD_LB_DelString`
 
-!macro __NSD_LB_Clear CONTROL VAR
+!define NSD_LB_GetSelectionIndex `!insertmacro __NSD_LB_GetSelectionIndex `
+!macro __NSD_LB_GetSelectionIndex CONTROL VAR
+	SendMessage ${CONTROL} ${LB_GETCURSEL} 0 0 ${VAR}
+!macroend
 
-	SendMessage ${CONTROL} ${LB_RESETCONTENT} 0 0 ${VAR}
 
+!define NSD_LB_SetSelectionIndex `!insertmacro __NSD_LB_SetSelectionIndex `
+!macro __NSD_LB_SetSelectionIndex CONTROL INDEX
+	SendMessage ${CONTROL} ${LB_SETCURSEL} ${INDEX} 0
 !macroend
 
-!define NSD_LB_Clear `!insertmacro __NSD_LB_Clear`
 
-!macro __NSD_LB_GetCount CONTROL VAR
+!define NSD_LB_GetSelectionCount `!insertmacro __NSD_LB_GetSelectionCount `
+!macro __NSD_LB_GetSelectionCount CONTROL VAR
+	SendMessage ${CONTROL} ${LB_GETSELCOUNT} 0 0 ${VAR}
+!macroend
 
-	SendMessage ${CONTROL} ${LB_GETCOUNT} 0 0 ${VAR}
 
+!define NSD_LB_GetItemText `!insertmacro __NSD_LB_GetItemText `
+!macro __NSD_LB_GetItemText CONTROL INDEX VAR
+	System::Call 'user32::SendMessage(p${CONTROL}, i${LB_GETTEXT}, p${INDEX}, t.s)'
+	Pop ${VAR}
 !macroend
 
-!define NSD_LB_GetCount `!insertmacro __NSD_LB_GetCount`
 
-!macro _NSD_LB_SelectString CONTROL STRING
+!define NSD_LB_GetItemData `!insertmacro __NSD_LB_GetItemData `
+!macro __NSD_LB_GetItemData CONTROL INDEX VAR
+SendMessage ${CONTROL} ${LB_GETITEMDATA} ${INDEX} 0 ${VAR}
+!macroend
+!define NSD_LB_SetItemData `${__NSD_MkCtlCmd_WPLP} LB_SETITEMDATA ` ; Index Data
 
-	SendMessage ${CONTROL} ${LB_SELECTSTRING} -1 `STR:${STRING}`
 
+!define NSD_LB_FindStringPrefix `!insertmacro __NSD_LB_FindStringPrefix `
+!macro __NSD_LB_FindStringPrefix CONTROL STRING VAR
+	SendMessage ${CONTROL} ${LB_FINDSTRING} -1 `STR:${STRING}` ${VAR}
 !macroend
 
-!define NSD_LB_SelectString "!insertmacro _NSD_LB_SelectString"
 
-!macro __NSD_LB_GetSelection CONTROL VAR
+!define NSD_LB_FindStringExact `!insertmacro __NSD_LB_FindStringExact `
+!macro __NSD_LB_FindStringExact CONTROL STRING VAR
+	SendMessage ${CONTROL} ${LB_FINDSTRINGEXACT} -1 `STR:${STRING}` ${VAR}
+!macroend
 
-	SendMessage ${CONTROL} ${LB_GETCURSEL} 0 0 ${VAR}
-	System::Call 'user32::SendMessage(i ${CONTROL}, i ${LB_GETTEXT}, i ${VAR}, t .s)'
-	Pop ${VAR}
 
+### ProgressBar ###
+
+!define NSD_ProgressBar_SetPos `${__NSD_MkCtlCmd_WP} PBM_SETPOS 0 `
+!define NSD_ProgressBar_SetStep `${__NSD_MkCtlCmd_WP} PBM_SETSTEP 0 `
+!define NSD_ProgressBar_StepIt `${__NSD_MkCtlCmd} PBM_STEPIT 0 0 `
+!define NSD_ProgressBar_AdvanceBy `${__NSD_MkCtlCmd_WP} PBM_DELTAPOS 0 `
+!define NSD_ProgressBar_SetPackedRange `${__NSD_MkCtlCmd_LP} PBM_SETRANGE 0 ` ; LP(DWORD):MAKELONG(min,max)
+!define NSD_ProgressBar_SetRange32 `${__NSD_MkCtlCmd_WPLP} PBM_SETRANGE32 ` ; [IE3+] WP:min LP:max
+!define NSD_ProgressBar_GetPos `${__NSD_MkCtlCmd_RV} PBM_GETPOS 0 0 ` ; [IE3+]
+
+
+### Animation ###
+
+!define NSD_Anim_Close `${__NSD_MkCtlCmd} ACM_OPEN 0 0 `
+!define NSD_Anim_Play `${__NSD_MkCtlCmd} ACM_PLAY -1 0xFFFF0000 `
+!define NSD_Anim_PlayLoops `${__NSD_MkCtlCmd_WP} ACM_PLAY 0xFFFF0000 ` ; WP(UINT16):LoopCount
+!define NSD_Anim_Stop `${__NSD_MkCtlCmd} ACM_STOP 0 0 `
+!define NSD_Anim_IsPlaying `${__NSD_MkCtlCmd_RV} ACM_ISPLAYING 0 0 `
+
+!define NSD_Anim_OpenFile `!insertmacro __NSD_Anim_OpenFile `
+!macro __NSD_Anim_OpenFile CONTROL PATH
+	SendMessage ${CONTROL} ${ACM_OPEN} 0 "STR:${PATH}"
 !macroend
 
-!define NSD_LB_GetSelection `!insertmacro __NSD_LB_GetSelection`
+!define NSD_Anim_OpenResource `!insertmacro __NSD_Anim_OpenResource `
+!macro __NSD_Anim_OpenResource CONTROL HINSTANCE_CC471 RESID
+	SendMessage ${CONTROL} ${ACM_OPEN} "${HINSTANCE_CC471}" "${RESID}"
+!macroend
 
 
-!macro __NSD_LoadAndSetImage _LIHINSTMODE _IMGTYPE _LIHINSTSRC _LIFLAGS CONTROL IMAGE HANDLE
-	
-	Push $0
-	Push $R0
+### TrackBar ###
 
-	StrCpy $R0 ${CONTROL} # in case ${CONTROL} is $0
-	
-	!if "${_LIHINSTMODE}" == "exeresource"
-		System::Call 'kernel32::GetModuleHandle(i0) i.r0'
-		!undef _LIHINSTSRC
-		!define _LIHINSTSRC r0
-	!endif
-	
-	System::Call 'user32::LoadImage(i ${_LIHINSTSRC}, ts, i ${_IMGTYPE}, i0, i0, i${_LIFLAGS}) i.r0' "${IMAGE}"
-	SendMessage $R0 ${STM_SETIMAGE} ${_IMGTYPE} $0
+!define NSD_TrackBar_GetPos `${__NSD_MkCtlCmd_RV} TBM_GETPOS 0 0 `
+!define NSD_TrackBar_SetPos `${__NSD_MkCtlCmd_LP} TBM_SETPOS 1 `
+!define NSD_TrackBar_SetRangeMin `${__NSD_MkCtlCmd_LP} TBM_SETRANGEMIN 1 `
+!define NSD_TrackBar_SetRangeMax `${__NSD_MkCtlCmd_LP} TBM_SETRANGEMAX 1 `
+!define NSD_TrackBar_GetLineSize `${__NSD_MkCtlCmd_RV} TBM_GETLINESIZE 0 0 `
+!define NSD_TrackBar_SetLineSize `${__NSD_MkCtlCmd_LP} TBM_SETLINESIZE 0 `
+!define NSD_TrackBar_GetPageSize `${__NSD_MkCtlCmd_RV} TBM_GETPAGESIZE 0 0 `
+!define NSD_TrackBar_SetPageSize `${__NSD_MkCtlCmd_LP} TBM_SETPAGESIZE 0 `
+!define NSD_TrackBar_ClearTics `${__NSD_MkCtlCmd} TBM_CLEARTICS 0 0 `
+!define NSD_TrackBar_GetNumTics `${__NSD_MkCtlCmd_RV} TBM_GETNUMTICS 0 0 `
+!define NSD_TrackBar_SetTic `${__NSD_MkCtlCmd_LP} TBM_SETTIC 0 `
+!define NSD_TrackBar_SetTicFreq `${__NSD_MkCtlCmd_WP} TBM_SETTICFREQ 0 `
+!define NSD_TrackBar_GetThumbLength `${__NSD_MkCtlCmd_RV} TBM_GETTHUMBLENGTH 0 0 `
+!define NSD_TrackBar_SetBuddy `${__NSD_MkCtlCmd_WPLP} TBM_SETBUDDY ` ; WP(BOOL):Left/Right LP:HWND
 
-	Pop $R0
-	Exch $0
 
-	Pop ${HANDLE}
+### UpDown ###
 
-!macroend
+!define NSD_UD_SetBuddy `${__NSD_MkCtlCmd_WP} UDM_SETBUDDY 0 `
+!define NSD_UD_GetPos `${__NSD_MkCtlCmd_RV} UDM_GETPOS 0 0 `
+!define NSD_UD_SetPos `${__NSD_MkCtlCmd_LP} UDM_SETPOS 0 `
+!define NSD_UD_GetPackedRange `${__NSD_MkCtlCmd_RV} UDM_GETRANGE 0 0 `
+!define NSD_UD_SetPackedRange `${__NSD_MkCtlCmd_LP} UDM_SETRANGE 0 ` ; LP(DWORD):MAKELONG(min,max)
+!define NSD_UD_GetPos32 `${__NSD_MkCtlCmd_RV} UDM_GETPOS32 0 0 `
+!define NSD_UD_SetPos32 `${__NSD_MkCtlCmd_LP} UDM_SETPOS32 0 `
+!define NSD_UD_SetRange32 `${__NSD_MkCtlCmd_WPLP} UDM_SETRANGE32 ` ; WP(INT32):min LP(INT32):max
 
-!macro __NSD_SetIconFromExeResource CONTROL IMAGE HANDLE
-	!insertmacro __NSD_LoadAndSetImage exeresource ${IMAGE_ICON} 0 ${LR_DEFAULTSIZE} "${CONTROL}" "${IMAGE}" ${HANDLE}
+!define NSD_UD_GetRange32 `!insertmacro __NSD_UD_GetRange32 `
+!macro __NSD_UD_GetRange32 CONTROL OUTLO OUTHI
+	System::Call 'USER32::SendMessage(p${CONTROL},i${UDM_GETRANGE32},*i.s,*i.s)'
+	Pop ${OUTLO}
+	Pop ${OUTHI}
 !macroend
 
-!macro __NSD_SetIconFromInstaller CONTROL HANDLE
-	!insertmacro __NSD_SetIconFromExeResource "${CONTROL}" "#103" ${HANDLE}
+!define NSD_UD_SetStaticRange `!insertmacro __NSD_UD_SetStaticRange `
+!macro __NSD_UD_SetStaticRange CONTROL MI MA
+	!define /redef /math MI ${MI} << 16
+	!define /redef /math MA ${MA} & 0xffff
+	!define /redef /math MA ${MI} | ${MA}
+	SendMessage ${CONTROL} ${UDM_SETRANGE} 0 ${MA}
 !macroend
 
-!define NSD_SetImage `!insertmacro __NSD_LoadAndSetImage file ${IMAGE_BITMAP} 0 "${LR_LOADFROMFILE}"`
-!define NSD_SetBitmap `${NSD_SetImage}`
 
-!define NSD_SetIcon `!insertmacro __NSD_LoadAndSetImage file ${IMAGE_ICON} 0 "${LR_LOADFROMFILE}|${LR_DEFAULTSIZE}"`
-!define NSD_SetIconFromExeResource `!insertmacro __NSD_SetIconFromExeResource`
-!define NSD_SetIconFromInstaller `!insertmacro __NSD_SetIconFromInstaller`
+### HotKey ###
 
+!define NSD_HK_GetHotKey `${__NSD_MkCtlCmd_RV} HKM_GETHOTKEY 0 0 ` ; RV(WORD):MAKEWORD(VK,HOTKEYF)
+!define NSD_HK_SetHotKey `${__NSD_MkCtlCmd_WP} HKM_SETHOTKEY 0 `
+!define NSD_HK_SetRules `${__NSD_MkCtlCmd_WPLP} HKM_SETRULES `
 
-!macro __NSD_SetStretchedImage CONTROL IMAGE HANDLE
 
-	Push $0
-	Push $1
-	Push $2
-	Push $R0
+### IP Address ###
 
-	StrCpy $R0 ${CONTROL} # in case ${CONTROL} is $0
+!define NSD_IPAddress_Clear `${__NSD_MkCtlCmd} IPM_CLEARADDRESS 0 0 `
+!define NSD_IPAddress_SetPackedIPv4 `${__NSD_MkCtlCmd_LP} IPM_SETADDRESS 0 `
+!define NSD_IPAddress_IsBlank `${__NSD_MkCtlCmd_RV} IPM_ISBLANK 0 0 `
 
-	StrCpy $1 ""
-	StrCpy $2 ""
+!define NSD_IPAddress_GetPackedIPv4 `!insertmacro __NSD_IPAddress_GetPackedIPv4 `
+!macro __NSD_IPAddress_GetPackedIPv4 CONTROL VAR
+System::Call 'USER32::SendMessage(p${CONTROL},i${IPM_GETADDRESS},p0,*i0s)'
+Pop ${VAR}
+!macroend
 
-	System::Call '*(i, i, i, i) i.s'
-	Pop $0
 
-	${If} $0 <> 0
-	
-		System::Call 'user32::GetClientRect(iR0, ir0)'
-		System::Call '*$0(i, i, i .s, i .s)'
-		System::Free $0
-		Pop $1
-		Pop $2
+### Date ###
+!define NSD_Date_GetDateFields `!insertmacro __NSD_Date_GetDateFields `
+!macro __NSD_Date_GetDateFields CONTROL
+Push $0
+System::Call 'USER32::SendMessage(p${CONTROL},i${DTM_GETSYSTEMTIME},p0,@r0)'
+System::Call '*$0(&i2.s,&i2.s,&i2,&i2.s)'
+Exch 3
+Pop $0
+!macroend
 
-	${EndIf}
+!define NSD_Time_GetTimeFields `!insertmacro __NSD_Time_GetTimeFields `
+!macro __NSD_Time_GetTimeFields CONTROL
+Push $0
+System::Call 'USER32::SendMessage(p${CONTROL},i${DTM_GETSYSTEMTIME},p0,@r0)'
+System::Call '*$0(&i2,&i2,&i2,&i2,&i2.s,&i2.s,&i2.s)'
+Exch 3
+Pop $0
+Exch
+!macroend
 
-	System::Call 'user32::LoadImage(i0, ts, i ${IMAGE_BITMAP}, ir1, ir2, i${LR_LOADFROMFILE}) i.s' "${IMAGE}"
-	Pop $0
-    SendMessage $R0 ${STM_SETIMAGE} ${IMAGE_BITMAP} $0
 
-	Pop $R0
-	Pop $2
-	Pop $1
-	Exch $0
+### Static ###
 
-	Pop ${HANDLE}
+!macro __NSD_LoadAndSetImage _LIHINSTMODE _IMGTYPE _LIHINSTSRC _LIFLAGS CONTROL IMAGE HANDLE
+	!if "${_LIHINSTMODE}" == "exeresource"
+		LoadAndSetImage /EXERESOURCE /STRINGID "${CONTROL}" ${_IMGTYPE} ${_LIFLAGS} "${IMAGE}" ${HANDLE}
+	!else #if "${_LIHINSTMODE}" == "file"
+		LoadAndSetImage /STRINGID "${CONTROL}" ${_IMGTYPE} ${_LIFLAGS} "${IMAGE}" ${HANDLE}
+	!endif
+!macroend
 
+!macro __NSD_SetIconFromExeResource CONTROL IMAGE HANDLE
+	LoadAndSetImage /EXERESOURCE /STRINGID "${CONTROL}" ${IMAGE_ICON} ${LR_DEFAULTSIZE} "${IMAGE}" ${HANDLE}
 !macroend
 
-!define NSD_SetStretchedImage `!insertmacro __NSD_SetStretchedImage`
+!macro __NSD_SetIconFromInstaller CONTROL HANDLE
+	LoadAndSetImage /EXERESOURCE "${CONTROL}" ${IMAGE_ICON} ${LR_DEFAULTSIZE} 103 ${HANDLE}
+!macroend
 
-!macro __NSD_FreeImage IMAGE
+!define NSD_SetImage `!insertmacro __NSD_LoadAndSetImage file ${IMAGE_BITMAP} 0 "${LR_LOADFROMFILE}" `
+!define NSD_SetBitmap `${NSD_SetImage} `
 
-	${If} ${IMAGE} <> 0
+!define NSD_SetIcon `!insertmacro __NSD_LoadAndSetImage file ${IMAGE_ICON} 0 "${LR_LOADFROMFILE}|${LR_DEFAULTSIZE}" `
+!define NSD_SetIconFromExeResource `!insertmacro __NSD_SetIconFromExeResource `
+!define NSD_SetIconFromInstaller `!insertmacro __NSD_SetIconFromInstaller `
 
-		System::Call gdi32::DeleteObject(is) ${IMAGE}
 
+!define NSD_SetStretchedImage `!insertmacro __NSD_SetStretchedImage `
+!define NSD_SetStretchedBitmap `!insertmacro __NSD_SetStretchedImage `
+!macro __NSD_SetStretchedImage CONTROL IMAGE HANDLE
+	LoadAndSetImage /STRINGID /RESIZETOFIT "${CONTROL}" ${IMAGE_BITMAP} ${LR_LOADFROMFILE} "${IMAGE}" ${HANDLE}
+!macroend
+
+
+!define NSD_FreeImage `!insertmacro __NSD_FreeImage `
+!define NSD_FreeBitmap `${NSD_FreeImage} `
+!macro __NSD_FreeImage IMAGE
+	${If} ${IMAGE} P<> 0
+		System::Call gdi32::DeleteObject(ps) ${IMAGE}
 	${EndIf}
-
 !macroend
 
-!define NSD_FreeImage `!insertmacro __NSD_FreeImage`
-!define NSD_FreeBitmap `${NSD_FreeImage}`
 
+!define NSD_FreeIcon `!insertmacro __NSD_FreeIcon `
 !macro __NSD_FreeIcon IMAGE
-	System::Call user32::DestroyIcon(is) ${IMAGE}
+	System::Call user32::DestroyIcon(ps) ${IMAGE}
 !macroend
 
-!define NSD_FreeIcon `!insertmacro __NSD_FreeIcon`
 
+!define NSD_ClearImage `!insertmacro __NSD_ClearImage ${IMAGE_BITMAP} `
+!define NSD_ClearBitmap `${NSD_ClearImage} `
+!define NSD_ClearIcon  `!insertmacro __NSD_ClearImage ${IMAGE_ICON } `
 !macro __NSD_ClearImage _IMGTYPE CONTROL
-
 	SendMessage ${CONTROL} ${STM_SETIMAGE} ${_IMGTYPE} 0
-
 !macroend
 
-!define NSD_ClearImage `!insertmacro __NSD_ClearImage ${IMAGE_BITMAP}`
-!define NSD_ClearIcon  `!insertmacro __NSD_ClearImage ${IMAGE_ICON}`
 
+### INI ###
 
-!define DEBUG `System::Call kernel32::OutputDebugString(ts)`
+!define /IfNDef NSD_Debug `System::Call kernel32::OutputDebugString(ts)`
 
 !macro __NSD_ControlCase TYPE
-
 	${Case} ${TYPE}
 		${NSD_Create${TYPE}} $R3u $R4u $R5u $R6u $R7
 		Pop $R9
 		${Break}
-
 !macroend
 
 !macro __NSD_ControlCaseEx TYPE
-
 	${Case} ${TYPE}
 		Call ${TYPE}
 		${Break}
-
 !macroend
 
 !macro NSD_FUNCTION_INIFILE
-
 	!insertmacro NSD_INIFILE ""
-
 !macroend
 
 !macro NSD_UNFUNCTION_INIFILE
-
 	!insertmacro NSD_INIFILE un.
-
 !macroend
 
 !macro NSD_INIFILE UNINSTALLER_FUNCPREFIX
@@ -670,26 +1046,26 @@
 
 		ReadINIStr $R0 $0 Settings NumFields
 
-		${DEBUG} "NumFields = $R0"
+		${NSD_Debug} "NumFields = $R0"
 
 		${For} $R1 1 $R0
-			${DEBUG} "Creating field $R1"
+			${NSD_Debug} "Creating field $R1"
 			ReadINIStr $R2 $0 "Field $R1" Type
-			${DEBUG} "  Type = $R2"
+			${NSD_Debug} "  Type = $R2"
 			ReadINIStr $R3 $0 "Field $R1" Left
-			${DEBUG} "  Left = $R3"
+			${NSD_Debug} "  Left = $R3"
 			ReadINIStr $R4 $0 "Field $R1" Top
-			${DEBUG} "  Top = $R4"
+			${NSD_Debug} "  Top = $R4"
 			ReadINIStr $R5 $0 "Field $R1" Right
-			${DEBUG} "  Right = $R5"
+			${NSD_Debug} "  Right = $R5"
 			ReadINIStr $R6 $0 "Field $R1" Bottom
-			${DEBUG} "  Bottom = $R6"
+			${NSD_Debug} "  Bottom = $R6"
 			IntOp $R5 $R5 - $R3
-			${DEBUG} "  Width = $R5"
+			${NSD_Debug} "  Width = $R5"
 			IntOp $R6 $R6 - $R4
-			${DEBUG} "  Height = $R6"
+			${NSD_Debug} "  Height = $R6"
 			ReadINIStr $R7 $0 "Field $R1" Text
-			${DEBUG} "  Text = $R7"
+			${NSD_Debug} "  Text = $R7"
 			${Switch} $R2
 				!insertmacro __NSD_ControlCase   HLine
 				!insertmacro __NSD_ControlCase   VLine
@@ -719,11 +1095,11 @@
 
 	Function ${UNINSTALLER_FUNCPREFIX}UpdateINIState
 
-		${DEBUG} "Updating INI state"
+		${NSD_Debug} "Updating INI state"
 
 		ReadINIStr $R0 $0 Settings NumFields
 
-		${DEBUG} "NumField = $R0"
+		${NSD_Debug} "NumField = $R0"
 
 		${For} $R1 1 $R0
 			ReadINIStr $R2 $0 "Field $R1" HWND
@@ -731,14 +1107,14 @@
 			${Switch} $R3
 				${Case} "CheckBox"
 				${Case} "RadioButton"
-					${DEBUG} "  HWND = $R2"
+					${NSD_Debug} "  HWND = $R2"
 					${NSD_GetState} $R2 $R2
-					${DEBUG} "  Window selection = $R2"
+					${NSD_Debug} "  Window selection = $R2"
 				${Break}
 				${CaseElse}
-					${DEBUG} "  HWND = $R2"
+					${NSD_Debug} "  HWND = $R2"
 					${NSD_GetText} $R2 $R2
-					${DEBUG} "  Window text = $R2"
+					${NSD_Debug} "  Window text = $R2"
 				${Break}
 			${EndSwitch}
 			WriteINIStr $0 "Field $R1" STATE $R2
Index: tmp/org.txm.setups/nsis/Include/Integration.nsh
===================================================================
--- tmp/org.txm.setups/nsis/Include/Integration.nsh	(revision 0)
+++ tmp/org.txm.setups/nsis/Include/Integration.nsh	(revision 2956)
@@ -0,0 +1,44 @@
+!verbose push 3
+!ifndef INTEGRATION_INCLUDED
+!define INTEGRATION_INCLUDED 1
+
+!include "Util.nsh"
+
+
+!define NotifyShell_AssocChanged `System::Call 'SHELL32::SHChangeNotify(i0x8000000,i0,p0,p0)'` ; Notify the shell with SHCNE_ASSOCCHANGED
+
+
+!define UnpinShortcut "!insertmacro UnpinShortcut "
+!macro UnpinShortcut lnkpath
+Push "${lnkpath}"
+${CallArtificialFunction} UnpinShortcut_Implementation
+!macroend
+!macro UnpinShortcut_Implementation
+!include "LogicLib.nsh"
+!include "Win\COM.nsh"
+Exch $0
+Push $1
+!insertmacro ComHlpr_CreateInProcInstance ${CLSID_StartMenuPin} ${IID_IStartMenuPinnedList} r1 ""
+${If} $1 P<> 0
+    System::Call 'SHELL32::SHCreateItemFromParsingName(wr0,p0,g"${IID_IShellItem}",*p0r0)'
+    ${If} $0 P<> 0
+        ${IStartMenuPinnedList::RemoveFromList} $1 '(r0)'
+        ${IUnknown::Release} $0 ""
+    ${EndIf}
+    ${IUnknown::Release} $1 ""
+!ifdef NSIS_IX86 | NSIS_AMD64
+${Else}
+  !insertmacro ComHlpr_CreateInProcInstance ${CLSID_StartMenuPin} "{ec35e37a-6579-4f3c-93cd-6e62c4ef7636}" r1 ""
+  ${If} $1 P<> 0
+    ExecShellWait /INVOKEIDLIST "unpin" $0 ; WinXP
+    ${IUnknown::Release} $1 ""
+  ${EndIf}
+!endif
+${EndIf}
+Pop $1
+Pop $0
+!macroend
+
+
+!endif #!INCLUDED
+!verbose pop
